int comb( int n, r; ) {
	if ( r < 0 || r > n )
		return 0;
	else if ( r == 0 || r == n )
		return 1;
	else
		return comb( n - 1, r - 1 ) + comb( n - 1, r );
	}
[]char pad( int n, padlen; ) {
	[]char s = "" + n;
	while ( size s < padlen )
		s = " " + s;
	return s;
	}
for ( int n = 0; n < 10; n++ ) {
	for ( int r = 9; r > n; --r )
		print( "    " );
	for ( int r = 0; r <= n; r++ )
		print( pad( comb( n, r ), 8 ) );
	println( "" );
	}
